package cordova.plugins;

import org.apache.cordova.CordovaWebView;
import org.apache.cordova.CallbackContext;
import org.apache.cordova.CordovaPlugin;
import org.apache.cordova.PluginResult;
import org.apache.cordova.CordovaInterface;
import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import com.stroeven.greeter.*;
import com.viatom.azur.bluetooth.*;
import com.viatom.azur.measurement.*;
import com.viatom.azur.utils.*;

import android.content.ServiceConnection;
import android.content.Intent;
import android.app.Service;
import android.content.ComponentName;
import android.os.IBinder;
import android.os.Binder;
import android.content.Context;
import android.content.pm.PackageManager;
import android.content.pm.ResolveInfo;
import java.util.List;

import android.util.Log;

import 	java.lang.InterruptedException;


public class checkMeInterface extends CordovaPlugin implements BTConnectListener, PingThreadListener{

    private CordovaInterface cordova;
    private CordovaWebView webView;
    private BTUtils.BTBinder mBinder;
    private CallbackContext callbackContext;

    private ServiceConnection conn = new ServiceConnection(){
         @Override
            public void onServiceConnected(ComponentName name, IBinder service){
            mBinder = (BTUtils.BTBinder) service;
            System.out.println("Service bound");
            PluginResult result = new PluginResult(PluginResult.Status.OK, "service connected::Service bound -> you may now use BTUtils");
            callbackContext.sendPluginResult(result);
         }

         @Override
         public void onServiceDisconnected (ComponentName name){
            System.out.println("Service has been disconnected.");
         }
     };

    public String testBindService(){

        	Intent intent = new Intent("com.viatom.azur.BTUtils");
        	intent.setPackage("com.viatom.azur");
        	if(cordova.getActivity().getApplicationContext().bindService(intent, conn, Service.BIND_AUTO_CREATE)){
        	    return "OUTCOME == true";
        	}else{
        	    return "OUTCOME == false";
        	}




    }

	@Override
    public void initialize(CordovaInterface cordova, CordovaWebView webView) {
    	super.initialize(cordova, webView);
    	this.cordova = cordova;
    	this.webView = webView;
    }

    @Override
    public boolean execute(String action, JSONArray args, CallbackContext callbackContext) throws JSONException {
        this.callbackContext = callbackContext;
        //PluginResult result = new PluginResult(PluginResult.Status.OK, "Starting transaction");
       // result.setKeepCallback(true);
        if(action.equals("initBTUtils")){

            callbackContext.success( testBindService());
        }
        if(action.equals("connectCheckMe")){
            if(testConnectCheckme(args.getString(0))){
                callbackContext.success("CHECKME "+ args.getString(0) +" CONNECTED");
            }else{
                callbackContext.error("CHECKME NOT CONNECTED");
            }
        }
        if(action.equals("pingCheckMe")){
           callbackContext.success(testPing());
        }
        return false;
    }


    public boolean testConnectCheckme(String macAddress){
    	if(mBinder != null){
    		mBinder.interfaceConnect(macAddress, this);
    		return true;
    	}else{
    		return false;
    	}
    }
    
    @Override
    public void onConnectSuccess(){
    		
    }
    
    @Override
    public void onConnectFailed(byte errCode){
    	
    }

    public String testPing(){

        if(mBinder != null){
            mBinder.interfacePing(1000, this);
            return "PING SUCCESS";
        }else{
        return "PING FAILED";
        }
    }

    @Override
    public void onPingSuccess(){
        // do something
    }

    @Override
        public void onPingFailed(byte errCode){
            // do something
    }
    
}